/*============================================================================
  File:     Parallelism.sql

  Summary:  Create some parallelism waits

  SQL Server Versions: 2005 onwards
------------------------------------------------------------------------------
  Written by Paul S. Randal, SQLskills.com

  (c) 2011, SQLskills.com. All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you include this copyright and give due
  credit, but you must obtain prior permission before blogging this code.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

/*
USE master;
GO
DROP DATABASE ParallelismTest;
GO

RESTORE DATABASE ParallelismTest FROM
DISK = 'D:\SQLskills\DemoBackups\Parallelism.bak'
WITH REPLACE, STATS;
GO
*/

USE ParallelismTest;
GO

SET NOCOUNT ON;
GO

DECLARE @ExecString VARCHAR (8000);

WHILE (1=1)
BEGIN
	-- Calculate doc name length
	SELECT @ExecString = 'SELECT TOP 10 * FROM NonSparseDocRepository ORDER BY c' +
		CAST (CONVERT (INT, RAND () * 1000) AS VARCHAR) +
		' DESC OPTION (MAXDOP 8)';
		
	--SELECT @ExecString;
	EXEC (@ExecString);
	--SELECT * FROM NonSparseDocRepository ORDER BY c10;
	
	WAITFOR DELAY '00:00:00.5';
END;
GO

-- Look at stats

-- Add in OPTION (MAXDOP 4), look at stats

-- Add in OPTION (MAXDOP 2), look at stats

-- Add in OPTION (MAXDOP 1), look at stats